﻿/// <reference path="../Scripts/jquery.js" />

/**************** FONCTION LPAD ****************/
// ajoute des caractères à gauche s'il n'y en a pas assez
function lpad(chObject, longueur, carAjout) {
	var resultat = chObject.toString();
	for (i = chObject.length + 1; i <= longueur; i++) {
		resultat = carAjout + resultat;
	}
	return resultat;
}

/* ///////////////////////////////////////////////////////////////////////////////////////////////////////// */

/* Pour l'exercice des cases à cocher */
var i = 0; var j = 0; var k = 0; var l = 0;
var numCasCheckbox = 0; // A CHANGER : nombre de questions
var nbRepParCheckbox = 0; // A CHANGER : nombre de réponses max par question
var tbCheckbox = new Array(numCasCheckbox); // Contient la lettre de la bonne réponse
var tbEstValide = new Array(numCasCheckbox); // Contient 1 si la réponse a été validée
var isUnique = false; // A CHANGER : mettre true pour un QCU et false pour un QCM
var isBilan = false; // A CHANGER : mettre true pour que ce soit un QCM bilan, sinon false
var questionAct = 1;

//////////////////////////// SAISIE DE TEXTE ////////////////////////////
var numChamps = 0; // A CHANGER : nombre de champs total
var tbCorriges = new Array(numChamps);
var nbTentatives = 0; // A CHANGER : 1, 2 ou 3 tentatives
var nbTentativesAct = 0;
var avecMsg = false; // A CHANGER : mettre true pour afficher un message après validation, sinon false
var isAffScore = false; // A CHANGER : mettre true pour afficher le score dans le message, sinon false
var isSolPermanent = false; // A CHANGER : mettre true pour que le btn solution soit visible dès le début, sinon false pour qu'il le soit à la fin
var isSolActif = false; // A CHANGER : mettre true pour activer le bouton solution, sinon false
var isSolInvisible = true; // A CHANGER : mettre true pour que le btn solution ne soit jamais affiché
var dejaMsg = 0;
var isVraieFin = false;
var nbMots = 0;
var tbMots = new Array(nbMots);
var tbRepDons = new Array(numChamps);
var nbLignes = 0;
var nbColons = 0;
var tbValeurs = new Array(numChamps);
var nbBonnesRepMot = 0;
var tbLettresPlacees = new Array();

//////////////////////////// Graine de Génie ////////////////////////////
var coulFondCase = true;

//////////////////////////// Delagrave ////////////////////////////
var tbBonnesRep = new Array();


var ecran_qu_act = 1;
if (sessionStorage.getItem("numEcranAct") == null || sessionStorage.getItem("numEcranAct") == "null")
	sessionStorage.setItem("numEcranAct", 1);
ecran_qu_act = Number(sessionStorage.getItem("numEcranAct"));
var ecran_qu_tot = 0;

var tbReponsesUser = new Array();

var typoMelangees = "";
var nbEcransTot = 0;
var typologie = "";

//////////////////////////// LES VARS SONT RENSEIGNÉES DIRECTEMENT DANS LE HTML ////////////////////////////
//////////////////////////// ACTIONS LANCÉES AU CHARGEMENT DE LA PAGE ////////////////////////////
function affecterVars(val1, val2, val3, val4, val5, val6, val7, val8, val9, val10, val11, val12, val13, val14, val15, val16, val17, val18, val19) {
	numChamps = val1; tbCorriges = val2; nbTentatives = val3;
	avecMsg = val4; isAffScore = val5; isSolPermanent = val6;
	isSolActif = val7; isSolInvisible = val8; tbSeuils = val9;
	nbMots = val10; tbMots = val11;
	nbLignes = val12; nbColons = val13; tbValeurs = val14;
	tbLettresPlacees = val15; isLangue = val16;
	typoMelangees = val17; nbEcransTot = val18; typologie = val19;
	
	////////// On initialise le tableaux des réponses que l'utilisateur à donné ///////////
	for (l = 0; l < nbLignes; l++) {
		tbRepDons[l] = new Array(nbColons);
		for (var m = 0; m < nbColons; m++) {
			tbRepDons[l][m] = tbValeurs[l][m];
			if (tbRepDons[l][m] == "0" || tbRepDons[l][m] == "1") tbRepDons[l][m] = "1";
		}
	}
	
	////////// On rend invisible le bouton Solution si on l'a demandé ///////////
	if (isSolInvisible == true) {
		$("#bouton_recommencer").css("visibility", "hidden");
		$("#btn_solution").css("visibility", "hidden");
	}
	
	////////// On fait disparaître le bouton Solution s'il n'est pas permament ///////////
	if (isSolPermanent == false) $("#btn_solution").hide();
	////////// On fait disparaître les boutons suivant/précédent car on en a pas besoin dans ce type d'exercice ///////////
	/*$("#bouton_prec").hide();
	$("#bouton_suiv").hide();*/
	$("#image_exercice").hide();
	
	// On réactive chaque champ de saisie (au cas où... pour le bouton recommencer)
	for (l = 1; l <= numChamps; l++) {
		document.getElementById("champ" + lpad(String(l), 2, "0")).value = "";
		document.getElementById("champ" + lpad(String(l), 2, "0")).disabled = false;
		
		// Pour remettre la couleur normale du champ de saisie
		$("#champ" + lpad(String(l), 2, "0")).focus(function (event) {
			var $this = $(this);
			$this.css("color", "#000");
		});
	}
	
	// On inscrit des lettres par défault
	for (l = 0; l < nbLignes; l++) {
		for (var m = 0; m < nbColons; m++) {
			//$(".phrase_rep." + lpad(String(l + 1), 2, "0") + "_" + lpad(String(m + 1), 2, "0")).val(tbValeurs[l][m]);
			$(".phrase_rep." + lpad(String(l + 1), 2, "0") + "_" + lpad(String(m + 1), 2, "0")).html(tbValeurs[l][m]);
		}
		/*$(".phrase_rep." + lpad(String(tbMots[l][0]), 2, "0") + "_" + lpad(String(tbMots[l][1]), 2, "0")).parent().html(
		$(".phrase_rep." + lpad(String(tbMots[l][0]), 2, "0") + "_" + lpad(String(tbMots[l][1]), 2, "0")).parent().html() + "<div class='numPhrase'>" + String(l + 1) + "</div>");*/
		/*$(".phrase_rep." + lpad(String(tbMots[l][0]), 2, "0") + "_" + lpad(String(tbMots[l][1]), 2, "0")).css("font-weight", "bold");
		$(".phrase_rep." + lpad(String(tbMots[l][0]), 2, "0") + "_" + lpad(String(tbMots[l][1]), 2, "0")).css("color", $(".numero").css("color"));*/
	}
	$("#champ" + $(".phrase_rep").length).val("");
	/*for (l = 0; l < tbLettresPlacees.length; l++) { // Lettres en plus...
		$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).val(tbValeurs[Number(tbLettresPlacees[l][0]) - 1][Number(tbLettresPlacees[l][1]) - 1]);
		$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).css("font-weight", "bold");
		$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).css("color", $(".numero").css("color"));
	}*/
	
	
	
	// On cache les boutons inutiles au départ
	$(".btn_solu_new, .btn_reco_new").hide();
	$(".pourc_bilan").hide();
	$(".btn_bilan").hide();
	
	$(".btn_solu_reelle").hide();
	
	$("#img_sol").hide();
	
	// On cache les boutons inutiles au départ (pour le bilan)
	$(".pourc_bilan").hide();
	$(".btn_voir_correction").hide();
	$(".btn_bilan, .btn_valider_new").hide();
	
	
	// On vérifie s'il y avait déjà des résultats donnés et on les remets
	MAJNumEcran();
	if (sessionStorage.getItem("reponsesUser" + sessionStorage.getItem("numEcranAct")) != null && sessionStorage.getItem("reponsesUser" + sessionStorage.getItem("numEcranAct")) != "null") {
		tbReponsesUser = JSON.parse(sessionStorage.getItem("reponsesUser" + sessionStorage.getItem("numEcranAct")));
		for (l = 1; l <= tbReponsesUser.length; l++) { // pour chaque champ de saisie du mots croisés
			/*var numCase = "";
			if (l <= 9) numCase = lpad(String(l), 2, "0");
			else numCase = String(l);
			
			$("#champ" + numCase).val(tbReponsesUser[l - 1]);
				if ($("#champ" + lpad(String(l), 2, "0")).css("background-color") == "rgb(203, 203, 203)" || $("#champ" + lpad(String(l), 2, "0")).css("background-color") == "rgb(47, 141, 10)" || $("#champ" + lpad(String(l), 2, "0")).css("background-color") == "rgb(202, 23, 25)")
				tbReponsesUser[tbReponsesUser.length] = "champ" + lpad(String(l), 2, "0");
			*/
			$("#" + tbReponsesUser[l - 1]).css("background-color", "rgb(203, 203, 203)");
		}
		// Si la validation a déjà été faite, alors on l'applique
		if (sessionStorage.getItem("validationFaite") != null && sessionStorage.getItem("validationFaite") != "null") {//alert("validée");
			$(".btn_bilan, .btn_reco_new").show();
			
			validerRep();
			//validerRep("sansScore");
			if (sessionStorage.getItem("nbBonnesRepEcran" + sessionStorage.getItem("numEcranAct")) != sessionStorage.getItem("nbVraiBonnesRepEcran" + sessionStorage.getItem("numEcranAct"))) $(".btn_solu_reelle").show();
			
			$(".pourc_bilan").hide();
		}
	}
}

// Pour savoir si une réponse est bonne. Retourne true si oui
function repEstBonne(valEntree, reponse) {
	var isRepBonne = false;
	
	if (valEntree == reponse) isRepBonne = true;
	if (valEntree == remplaLigature(reponse, "œ", "oe")) isRepBonne = true;
	if (valEntree == remplaLigature(reponse, "æ", "ae")) isRepBonne = true;
	if (valEntree == remplaLigature(reponse, "&", "et")) isRepBonne = true;
	
	return isRepBonne;
}
// Pour remplacer une ligature
function remplaLigature(reponse, carLigature, carRemplaLigature) {
	var newReponse = "";
	for (i = 1; i <= reponse.length; i++) {
		if (reponse.substring(i - 1, i) == carLigature) newReponse += carRemplaLigature;
		else newReponse += reponse.substring(i - 1, i);
	}
	return newReponse;
}

// Validation de l'exercice
var nbBonnesRepTmp = 0;
function validerRep(info) {
	var nbBonnesRep = 0; var nbMauvaisesRep = 0;
	var nbBonnesRepTot = 0;
	
	// Tout d'abord, on indique les bonnes reps case par case
	for (var n = 0; n < nbMots; n++) {
		var coulTxt = "";
		// Si c'est un mot horizontal, on le met en rouge
		if (tbMots[n][0] == tbMots[n][2]) coulTxt = "#3b7eed";
		//if (tbMots[n][1] == tbMots[n][3]) coulTxt = "black";
		if (tbMots[n][1] == tbMots[n][3]) coulTxt = "#3fc60a";
		if (tbMots[n][0] < tbMots[n][2] && tbMots[n][1] != tbMots[n][3]) coulTxt = "orange"; // diag descendante
		if (tbMots[n][0] > tbMots[n][2] && tbMots[n][1] != tbMots[n][3]) coulTxt = "purple"; // diag montante
		// Si le mot descend
		if (tbMots[n][0] <= tbMots[n][2]) {
			for (var l = tbMots[n][0]; l <= tbMots[n][2]; l++) {
				for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
					var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
					if (coulTxt != "orange" || (coulTxt == "orange" && (tbMots[n][2] - l == tbMots[n][3] - m))) {
						if (jQuery.inArray(caseAct.attr("class"), tbBonnesRep) == "-1") tbBonnesRep[tbBonnesRep.length] = caseAct.attr("class");
						//if (isLangue != "ang" && isLangue != "esp") {
							if (caseAct.css("color") == "rgb(10, 105, 132)") caseAct.css("color", "#054254");
							//else caseAct.css("color", coulTxt);
						//}
					}
				}
			}
		} else {
			// Si le mot monte...
			for (var l = tbMots[n][2]; l <= tbMots[n][0]; l++) {
				for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
					var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
					if ((l - tbMots[n][2] /*+ 1*/) == (tbMots[n][3] - m + tbMots[n][1] - 1)) {
						if (jQuery.inArray(caseAct.attr("class"), tbBonnesRep) == "-1") tbBonnesRep[tbBonnesRep.length] = caseAct.attr("class");
						//if (isLangue != "ang" && isLangue != "esp") {
							if (caseAct.css("color") == "rgb(10, 105, 132)") caseAct.css("color", "#054254");
							//else caseAct.css("color", coulTxt);
						//}
					}
				}
			}
		}
	}
	
	for (l = 1; l <= $(".phrase_rep").length; l++) {
		var caseAct = $("#champ" + lpad(String(l), 2, "0"));
		if (caseAct.css("background-color") != "rgb(203, 203, 203)" && caseAct.css("background-color") != "rgb(47, 141, 10)") {
			caseAct.css("background-color", "white");
			// On indique les bonnes réponses qu'on a pas répondu
			if (jQuery.inArray(caseAct.attr("class"), tbBonnesRep) != "-1") {
				/*caseAct.css("background-color", "#bfe8af");*/
			} else {
				/*if (isLangue != "ang" && isLangue != "esp")
					caseAct.css("color", "#b1b9bb");*/
			}
		} else {
			// On regarde si c'est une bonne ou mauvaise réponse
			if (jQuery.inArray(caseAct.attr("class"), tbBonnesRep) == "-1") {
				caseAct.css("background-color", "#be0a26");
				////caseAct.css("color", "#b1b9bb");
			} else {
				//nbBonnesRep++;
				caseAct.css("background-color", "#2f8d0a");
				/*caseAct.css("background-color", "#bfe8af");*/ // Vert pale
			}
		}
		
		// On compte combien de réponses au max il y a
	}
	
	// Il faut calculer le nombres de mots trouvés...
	for (var n = 0; n < nbMots; n++) {
		var motBon = true;
		
		// Si le mot descend
		if (tbMots[n][0] <= tbMots[n][2]) {
			for (var l = tbMots[n][0]; l <= tbMots[n][2]; l++) {
				for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
					var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
					
					// Si le mot est diagonal... (en descendant)
					if (tbMots[n][0] != tbMots[n][2] && tbMots[n][1] != tbMots[n][3]) {
						// Quand le mot descend...
						if (tbMots[n][0] < tbMots[n][2]) {
							if (tbMots[n][2] - l == tbMots[n][3] - m) {
								if (caseAct.css("background-color") == "rgb(47, 141, 10)" && jQuery.inArray(caseAct.attr("class"), tbBonnesRep) != "-1") {}
								else motBon = false;
							}
						}
					} else {
						if (caseAct.css("background-color") == "rgb(47, 141, 10)" && jQuery.inArray(caseAct.attr("class"), tbBonnesRep) != "-1") {}
						//if (caseAct.css("background-color") == "rgb(191, 232, 175)" && jQuery.inArray(caseAct.attr("class"), tbBonnesRep) != "-1") {}
						else motBon = false;
					}
				}
			}
		} else {
			// Quand le mot monte...
			for (var l = tbMots[n][2]; l <= tbMots[n][0]; l++) {
				for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
					var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
					
					//if (l == (tbMots[n][3] - tbMots[n][1] + m - 1)) {
					if ((l - tbMots[n][2] /*+ 1*/) == (tbMots[n][3] - m + tbMots[n][1] - 1)) {//alert(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
						if (caseAct.css("background-color") == "rgb(47, 141, 10)" && jQuery.inArray(caseAct.attr("class"), tbBonnesRep) != "-1") {}
						else motBon = false;
					}
				}
			}
		}
		if (motBon == true) nbBonnesRep++;
	}
	
	
	
	// Calcul et affichage du score si anglais ou espagnol
	//var scorePourc = Math.ceil((nbBonnesRep / tbBonnesRep.length) * 100);
	var scorePourc = Math.ceil((nbBonnesRep / nbMots) * 100);
	//if (scorePourc < 0) scorePourc = 0;
	
	
	
			// Il faut enregistrer à chaque fois ce que l'on fait...
			sessionStorage.setItem("nbBonnesRepEcran" + sessionStorage.getItem("numEcranAct"), nbBonnesRep);
			sessionStorage.setItem("nbVraiBonnesRepEcran" + sessionStorage.getItem("numEcranAct"), nbMots);
			
			tbReponsesUser = new Array();
			for (l = 1; l <= $("#crossword .phrase_rep").length; l++) {
			//for (l = 1; l <= 2; l++) {
				/*var numCase = "";
				if (l <= 9) numCase = lpad(String(l), 2, "0");
				else numCase = String(l);
				
				if ($("#champ" + numCase).val() != "") tbReponsesUser[l - 1] = $("#champ" + numCase).val();
				else tbReponsesUser[l - 1] = "";*/
				
				if ($("#champ" + lpad(String(l), 2, "0")).css("background-color") == "rgb(203, 203, 203)" || $("#champ" + lpad(String(l), 2, "0")).css("background-color") == "rgb(47, 141, 10)" || $("#champ" + lpad(String(l), 2, "0")).css("background-color") == "rgb(190, 10, 38)")
				tbReponsesUser[tbReponsesUser.length] = "champ" + lpad(String(l), 2, "0");
			}
			if (sessionStorage.getItem("validationFaite") == null || sessionStorage.getItem("validationFaite") == "null")
				sessionStorage.setItem("reponsesUser" + sessionStorage.getItem("numEcranAct"), JSON.stringify(tbReponsesUser));
		
		if (info != "sansScore") {
			var nbBonnesRepTotal = 0;
			var nbVraiBonnesRepTotal = 0;
			var scoreTotal = 0;
			
			for (var ibilan = 1; ibilan <= nbEcransTot; ibilan++) {
				nbBonnesRepTotal += Number(sessionStorage.getItem("nbBonnesRepEcran" + ibilan));
				nbVraiBonnesRepTotal += Number(sessionStorage.getItem("nbVraiBonnesRepEcran" + ibilan));
			}
			scoreTotal = Math.round((nbBonnesRepTotal / nbVraiBonnesRepTotal) * 100);
			sessionStorage.setItem("nbBonnesRepTotal", nbBonnesRepTotal);
			sessionStorage.setItem("nbVraiBonnesRepTotal", nbVraiBonnesRepTotal);
			sessionStorage.setItem("scoreTotal", scoreTotal);
			nbBonnesRep = sessionStorage.getItem("nbBonnesRepTotal");
			vraiNbBonnesRep = sessionStorage.getItem("nbVraiBonnesRepTotal");
			scorePourc = sessionStorage.getItem("scoreTotal");
		} else {
			nbBonnesRep = nbMots;
			vraiNbBonnesRep = nbMots;
		}

	
	if (isLangue == "ang") {
		$(".btn_reco_new").show();
		if (scorePourc == 100)
			$(".pourc_bilan_langues p").html("Score: " + nbBonnesRep + "/" + nbMots + "<br />Good Job!");
		else
			$(".pourc_bilan_langues p").html("Score: " + nbBonnesRep + "/" + nbMots + "<br />Sorry, wrong answer! Try again!");
	} else if (isLangue == "esp") {
		$(".btn_reco_new").show();
		if (scorePourc == 100)
			$(".pourc_bilan_langues p").html("Resultado: " + nbBonnesRep + "/" + nbMots + "<br />¡Enhorabuena!");
		else
			$(".pourc_bilan_langues p").html("Resultado: " + nbBonnesRep + "/" + nbMots + "<br />¡Hay errores, vuelve a intentarlo!");
	} else {
		$(".btn_solu_new").show();
		if (scorePourc >= 0 && scorePourc < 50)
			$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + nbMots + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />La plupart des notions ne sont pas maîtrisées.<br />Reportez-vous à votre cours pour identifier vos erreurs puis recommencez le test.");
		else if (scorePourc >= 50 && scorePourc < 70)
			$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + nbMots + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />Il vous manque encore des connaissances sur ce cours.<br />Reportez-vous à la correction pour identifier vos erreurs et définir les points du cours concernés.");
		else if (scorePourc >= 70 && scorePourc < 99)
			$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + nbMots + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />C’est bien ! La majorité des notions semblent acquises mais certaines peuvent être à revoir ou à approfondir.");
		else if (scorePourc == 100)
			$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + nbMots + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />Félicitations ! Vous maîtrisez parfaitement toutes les notions du cours !");
		$(".btn_bilan").click();
	}
	
	$(".btn_valider_new").hide();
	$(".btn_reco_new").show();
	
	if ((isLangue == "ang" || isLangue == "esp") && nbBonnesRep != nbMots) $(".btn_solu_reelle").show();
	
	
	
	if (info != "sansScore") {
		/*$(".btn_bilan").show(); $(".btn_bilan").click();
		
		
		$(".btn_valider_new").hide();
		$(".btn_reco_new").show();*/
		
		// On affiche alors les bonnes réponses
		//$(".btn_solu_new").click();
		
		sessionStorage.setItem("validationFaite", "true");
		
		if (sessionStorage.getItem("validationFaite") != null && sessionStorage.getItem("validationFaite") != "null") {
		} else {
			//if (isLangue != "ang" && isLan!= "esp") $(".btn_solu_reelle").click();
			//if (isLangue != "ang" && isLangue != "esp") btn_solu_reelle();
		}
	}
}

// Bouton solution réelle
function btn_solu_reelle() {
	$(".btn_solu_reelle").hide();
	
	/*for (var n = 0; n < nbMots; n++) {
		var coulTxt = "";
		// Si c'est un mot horizontal, on le met en rouge
		if (tbMots[n][0] == tbMots[n][2]) coulTxt = "#3b7eed";
		//if (tbMots[n][1] == tbMots[n][3]) coulTxt = "black";
		if (tbMots[n][1] == tbMots[n][3]) coulTxt = "#3fc60a";
		if (tbMots[n][0] < tbMots[n][2] && tbMots[n][1] != tbMots[n][3]) coulTxt = "orange"; // diag descendante
		if (tbMots[n][0] > tbMots[n][2] && tbMots[n][1] != tbMots[n][3]) coulTxt = "purple"; // diag montante
		// Si le mot descend
		if (tbMots[n][0] <= tbMots[n][2]) {
			for (var l = tbMots[n][0]; l <= tbMots[n][2]; l++) {
				for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
					var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
					if (coulTxt != "orange" || (coulTxt == "orange" && (tbMots[n][2] - l == tbMots[n][3] - m))) {
						if (caseAct.css("color") == "rgb(10, 105, 132)") caseAct.css("color", "#054254");
						else caseAct.css("color", coulTxt);
					}
				}
			}
		} else {
			// Si le mot monte...
			for (var l = tbMots[n][2]; l <= tbMots[n][0]; l++) {
				for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
					var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
					if ((l - tbMots[n][2]) == (tbMots[n][3] - m + tbMots[n][1] - 1)) {
						if (caseAct.css("color") == "rgb(10, 105, 132)") caseAct.css("color", "#054254");
						else caseAct.css("color", coulTxt);
					}
				}
			}
		}
	}
	
	// Et on met en gris les lettres qui ne doivent pas être utilisées
	for (var l = 1; l <= nbLignes; l++) {
		for (var m = 1; m <= nbColons; m++) {
			var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
			if (caseAct.css("color") == "rgb(0, 0, 0)" && caseAct.css("background-color") != "rgb(190, 10, 38)") caseAct.css("color", "#b1b9bb");
		}
	}*/
	
	// New solution
	$("#img_sol").show();
}

function validerRepOLD() {
	var nbBonnesRep = 0; var nbMauvaisesRep = 0;
	/*if ($("#champ" + $(".phrase_rep").length).val() == )*/
	var isRepBonne = false;
		
	// On vérifie si les bonnes réponses ont été données
	var tmpL; var nombreRepALaQues = 0; var repComparee = "";
	var nbVraisChamps = $(".vraiTxtTrous").length;
	for (l = $(".phrase_rep").length - nbVraisChamps + 1; l <= $(".phrase_rep").length; l++) { // pour chaque champ de saisie "vrai"
		isRepBonne = false;
		
		// On regarde le nombre de solutions possibles pour ce champ là
		//alert((l - $(".phrase_rep").length + nbVraisChamps) - 1)
		if (typeof tbCorriges[(l - $(".phrase_rep").length + nbVraisChamps) - 1] === 'string') nombreRepALaQues = 1;
		else nombreRepALaQues = tbCorriges[(l - $(".phrase_rep").length + nbVraisChamps) - 1].length;
		
		for (k = 1; k <= nombreRepALaQues; k++) {
			tmpL = String(l);
			
			var valEntreeTrim = $.trim(document.getElementById("champ" + lpad(tmpL, 2, "0")).value); // pour supprimer les espaces avant et après
			valEntreeTrim = valEntreeTrim.replace(/ +(?= )/g,''); // Pour supprimer les doubles/triples... espaces
			document.getElementById("champ" + lpad(tmpL, 2, "0")).value = valEntreeTrim;
			valEntreeTrim = valEntreeTrim.toLowerCase();
			
			/*var valEntreeTrim = $.trim(document.getElementById("champ" + lpad(k, 2, "0")).value); // pour supprimer les espaces avant et après
			valEntreeTrim = valEntreeTrim.replace(/ +(?= )/g,''); // Pour supprimer les doubles/triples... espaces
			document.getElementById("champ" + lpad(k, 2, "0")).value = valEntreeTrim;
			valEntreeTrim = valEntreeTrim.toLowerCase();*/
			
			if (nombreRepALaQues == 1) repComparee = tbCorriges[(l - $(".phrase_rep").length + nbVraisChamps) - 1]; // Dépend du
			else repComparee = tbCorriges[(l - $(".phrase_rep").length + nbVraisChamps) - 1][k - 1]; // nombre de solutions possibles
			
			repComparee = repComparee.toLowerCase();
			
			if (repEstBonne(valEntreeTrim, repComparee) == true) isRepBonne = true;
		}
		
		/*var ligCase = 0; var colCase = 0;
		ligCase = Number($("#champ" + lpad(tmpL, 2, "0")).attr("class").substr(-5, 2));
		colCase = Number($("#champ" + lpad(tmpL, 2, "0")).attr("class").substr(-2, 2));*/
		if (isRepBonne == true) {
			nbBonnesRep++;
			$("#champ" + lpad(tmpL, 2, "0")).css("color", "#2f8d0a");
			/*if (tbRepDons[ligCase - 1][colCase - 1] != "V")
				tbRepDons[ligCase - 1][colCase - 1] = "V";
			else
				tbRepDons[ligCase - 1][colCase - 1] = "O";*/
		} else {
			nbMauvaisesRep++;
			$("#champ" + lpad(tmpL, 2, "0")).css("color", "#be0a26");
			//$(".phrase_rep." + lpad(String(ligAct), 2, "0") + "_" + lpad(String(colAct), 2, "0")).focus().select();
			/*tbRepDons[ligCase - 1][colCase - 1] = "F";*/
		}
	}
	// pour indiquer qu'on a pas le droit de mettre 2 fois le même mot (même si c'est bon, on met le 1er en vert, les autres en rouge)
	for (l = $(".phrase_rep").length - nbVraisChamps + 1; l <= $(".phrase_rep").length; l++) {
		for (k = l + 1; k <= $(".phrase_rep").length; k++) {
			if (l != k && document.getElementById("champ" + lpad(l, 2, "0")).value == document.getElementById("champ" + lpad(k, 2, "0")).value) {
				nbBonnesRep = 0;
				$("#champ" + lpad(k, 2, "0")).css("color", "#be0a26");
			}
		}
	}
	
	var randMsg = Math.random();
	
	if (nbBonnesRep == nbVraisChamps) {
		if (randMsg <= 0.2) $("#msg_correction").attr("class", "messages-reponses bon01");
		else if (randMsg <= 0.4) $("#msg_correction").attr("class", "messages-reponses bon02");
		else if (randMsg <= 0.6) $("#msg_correction").attr("class", "messages-reponses bon03");
		else if (randMsg <= 0.8) $("#msg_correction").attr("class", "messages-reponses bon04");
		else $("#msg_correction").attr("class", "messages-reponses bon05");
	} else {
		if (randMsg <= 0.33) $("#msg_correction").attr("class", "messages-reponses intermediaire01");
		else if (randMsg <= 0.66) $("#msg_correction").attr("class", "messages-reponses intermediaire02");
		else $("#msg_correction").attr("class", "messages-reponses intermediaire03");
	}
	
	if (avecMsg == true) { // On affiche (ou non) le message de correction
		$("#msg_correction").fadeIn(1000);
		//$("#msg_correction").css("z-index", a++);
		dejaMsg++;
		setTimeout('faireDispMsg()', 4000);
	}
}
function validerRepOld() {
	var nbBonnesRep = 0; var nbMauvaisesRep = 0;
	var plurSing1 = " bonnes réponses"; var plurSing2 = " mauvaises réponses.";
	
	// On regarde à quelle tentative on est
	nbTentativesAct++;
	
	// On vérifie si les bonnes réponses ont été données
	var tmpL; var nombreRepALaQues = 0; var repComparee = "";
	var isRepBonne = false;
	for (l = 1; l <= numChamps; l++) { // pour chaque champ de saisie
		isRepBonne = false;
		
		// On regarde le nombre de solutions possibles pour ce champ là
		if (typeof tbCorriges[l - 1] === 'string') nombreRepALaQues = 1;
		else nombreRepALaQues = tbCorriges[l - 1].length;
		for (k = 1; k <= nombreRepALaQues; k++) {
			tmpL = String(l);
			
			var valEntreeTrim = $.trim(document.getElementById("champ" + lpad(tmpL, 2, "0")).value); // pour supprimer les espaces avant et après
			valEntreeTrim = valEntreeTrim.replace(/ +(?= )/g,''); // Pour supprimer les doubles/triples... espaces
			document.getElementById("champ" + lpad(tmpL, 2, "0")).value = valEntreeTrim;
			valEntreeTrim = valEntreeTrim.toLowerCase();
			
			if (nombreRepALaQues == 1) repComparee = tbCorriges[l - 1]; // Dépend du
			else repComparee = tbCorriges[l - 1][k - 1]; // nombre de solutions possibles
			//alert(k + ": " +repComparee);
			repComparee = repComparee.toLowerCase();
			
			if (repEstBonne(valEntreeTrim, repComparee) == true) isRepBonne = true;
		}
		
		var ligCase = 0; var colCase = 0;
		ligCase = Number($("#champ" + lpad(tmpL, 2, "0")).attr("class").substr(-5, 2));
		colCase = Number($("#champ" + lpad(tmpL, 2, "0")).attr("class").substr(-2, 2));
		if (isRepBonne == true) {
			nbBonnesRep++;
			$("#champ" + lpad(tmpL, 2, "0")).css("color", "#2f8d0a");
			if (tbRepDons[ligCase - 1][colCase - 1] != "V")
				tbRepDons[ligCase - 1][colCase - 1] = "V";
			else
				tbRepDons[ligCase - 1][colCase - 1] = "O";
		} else {
			nbMauvaisesRep++;
			$("#champ" + lpad(tmpL, 2, "0")).css("color", "#be0a26");
			//$(".phrase_rep." + lpad(String(ligAct), 2, "0") + "_" + lpad(String(colAct), 2, "0")).focus().select();
			tbRepDons[ligCase - 1][colCase - 1] = "F";
		}
	}
	
	
	// On met au pluriel/singulier si besoin
	/*if (nbBonnesRep == 1) plurSing1 = " bonne réponse";
	if (nbMauvaisesRep == 1) plurSing2 = " mauvaise réponse.";
	
	
	// On met au pluriel/singulier si besoin
	if (nbBonnesRep == 1) plurSing1 = " bonne réponse";
	if (nbMauvaisesRep == 1) plurSing2 = " mauvaise réponse.";
	
	var messageAlert = ""; var messageAlert1 = ""; var messageAlert2 = "";
	// On affiche un message, suivant les bonnes/mauvaises réponses
	if (nbBonnesRep == numChamps && nbMauvaisesRep == 0) {
		messageAlert1 = "Bravo, vous avez réussi parfaitement l'exercice ! Vous avez trouvé toutes les bonnes réponses";
		if (nbTentativesAct == 1)
			messageAlert1 += " et vous n'avez pas fait d'erreurs.";
		else if (nbTentativesAct == 2)
			messageAlert1 += " à la deuxième tentative.";
		else if (nbTentativesAct == 3)
			messageAlert1 += " à la troisième tentative.";
	} else {
		if (nbBonnesRep >= 0 && nbBonnesRep <= 0) {
			//alert("Vous avez " + nbBonnesRep + plurSing1 + " sur " + numChamps + " et " + nbMauvaisesRep + plurSing2);
			messageAlert1 = "As-tu bien appris ta leçon ? N'hésite pas à refaire le quiz après avoir révisé, pour améliorer ton score.";
		} else if (nbBonnesRep >= 1 && nbBonnesRep <= 1) {
			messageAlert1 = "Juste la moyenne ! Relis attentivement ta leçon avant de recommencer.";
		} else if (nbBonnesRep >= 2 && nbBonnesRep <= 2) {
			messageAlert1 = "C'est un bon début. Tu peux améliorer ton score.";
		} else if (nbBonnesRep >= 3 && nbBonnesRep <= 3) {
			messageAlert1 = "Bravo ! La prochaine fois, tu auras tout bon !";
		} else if (nbBonnesRep >= 4) {
			messageAlert1 = "Excellent ! C'est un sans faute !";
		}
		
		messageAlert2 = "\nTon score est de : " + nbBonnesRep + " / " + numChamps; 
	}
	messageAlert = messageAlert1 + messageAlert2;*/
	
	
	
	
	// Calcul du score pour les mots croisés
	/*nbBonnesRepMot = 0;
	for (l = 0; l < nbLignes; l++) {
		for (var m = 0; m < nbColons; m++) {
			if (tbRepDons[l][m] == "V")
				nbBonnesRepMot += 2;
			else if (tbRepDons[l][m] == "O")
				nbBonnesRepMot++;
		}
	}*/
	if ($(".texteScore").html() == "ScoreScoreScore") nbBonnesRepMot = 0;
	else nbBonnesRepMot /= 2;
	for (var n = 0; n < nbMots; n++) {
		var tmpBonRep = true;
		for (l = tbMots[n][0]; l <= tbMots[n][2]; l++) {
			for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
				if (tbRepDons[l - 1][m - 1] != "V" && tbRepDons[l - 1][m - 1] != "O") tmpBonRep = false;
			}
		}
		if (tmpBonRep == true) {
			if ($(".texteScore").html() == "ScoreScoreScore") nbBonnesRepMot += 2;
			else nbBonnesRepMot += 1;
		}
	}
	if (nbBonnesRepMot == (nbMots * 2)) {nbBonnesRepMot++; nbTentativesAct = nbTentatives;}
	
	// Si tout est bon, alors on peut directement afficher le message de fin
	//if (nbBonnesRep == numChamps) nbTentativesAct = nbTentatives;
	
	// Pour tester si le nombre de tentatives n'est pas dépassé
	if (nbTentativesAct == nbTentatives) {
		/*document.getElementById("msg1").innerHTML = messageAlert1;
		if (isAffScore == false) messageAlert2 = ""; // Cas selon on doit avoir le score ou pas
		document.getElementById("msg2").innerHTML = messageAlert2;
		if (avecMsg == true) { // On affiche (ou non) le message de correction
			$("#msg_correction").fadeIn(1000);dejaMsg++;
			setTimeout('faireDispMsg()', 4000);
		}*/
		
		for (l = 1; l <= numChamps; l++) { // On désactive alors chaque champ de saisie
			document.getElementById("champ" + lpad(String(l), 2, "0")).disabled = true;
		}
		$("#bouton_valider").hide();
		// On affiche le bouton solution quand la dernière tentative est passée
		isSolPermanent = true;
		$("#btn_solution").show();
		
		// transmission du score à l'élément parent
		/*if (isSolInvisible == true) {
			var isCookie = readCookie('scoreCookie');
			if (isCookie) {
				if (nbBonnesRep == numChamps) isCookie++;
				createCookie("scoreCookie", isCookie, 0);
			}
			var isCookie2 = readCookie('numEcranActCookie');
			var isCookie3 = readCookie('nbEcranTotCookie');
			if (isCookie2 && isCookie3) {//alert(isCookie2);
				if (isCookie2 == isCookie3) {createCookie("finExosCookie", "true", 0);}
			}
		}*/
	} else { // On affiche le nombre de tentatives si tout n'est pas bon
		/*document.getElementById("msg1").innerHTML = "Il vous reste " + (nbTentatives - nbTentativesAct) + " tentative";
		if ((nbTentatives - nbTentativesAct) != 1) document.getElementById("msg1").innerHTML += "s.";
		else document.getElementById("msg1").innerHTML += ".";
		document.getElementById("msg2").innerHTML = "";
		if (avecMsg == true) { // On affiche (ou non) le message de correction
			$("#msg_correction").fadeIn(1000);dejaMsg++;
			setTimeout('faireDispMsg()', 4000);
		}*/
	}
	
	
	
	
	
	
	// Affichage du message de remédiation + son
	var sonAlert;
	
	var randMsg = Math.random();
	
	if (nbBonnesRepMot == ((nbMots * 2) + 1) && nbTentativesAct == nbTentatives) {
		$("#msg_correction").attr("class", "messages-reponses bon");
		
		if (randMsg <= 0.5) {
			sonAlert = "_great";
			$("#msg_correction .texteMsg").html("Great");
		} else {
			sonAlert = "_welldone";
			$("#msg_correction .texteMsg").html("Well done");
		}
	} else if (nbTentativesAct == 1) {
		$("#msg_correction").attr("class", "messages-reponses intermediaire");
		sonAlert = "_tryagain";
		$("#msg_correction .texteMsg").html("No. Try again");
	} else {
		
		if ((nbBonnesRepMot - (nbBonnesRepTmp / 2)) == nbMots) {
			$("#msg_correction").attr("class", "messages-reponses bon");
			
			if (randMsg <= 0.5) {
				sonAlert = "_good";
				$("#msg_correction .texteMsg").html("Good");
			} else {
				sonAlert = "_right";
				$("#msg_correction .texteMsg").html("Right");
			}
		} else {
			$("#msg_correction").attr("class", "messages-reponses mauvais");
			sonAlert = "_sorrythatsnotright";
			$("#msg_correction .texteMsg").html("Sorry. That’s not right");
		}
	}
	nbBonnesRepTmp = nbBonnesRepMot;
	
	/*if (nbBonnesRepMot >= tbSeuils[0][0] && nbBonnesRepMot <= tbSeuils[0][1]) {
		sonAlert = "_tryagain";
		$("#msg_correction").attr("class", "messages-reponses mauvais");
		//$("#msg_correction .texteMsg").html("¡Vuelve a intentarlo!");
	} else if (nbBonnesRepMot >= tbSeuils[1][0] && nbBonnesRepMot <= tbSeuils[1][1]) {
		sonAlert = "_good";
		$("#msg_correction").attr("class", "messages-reponses intermediaire");
		//$("#msg_correction .texteMsg").html("¡No está nada mal!");
	} else if (nbBonnesRepMot >= tbSeuils[2][0] && nbBonnesRepMot <= tbSeuils[2][1]) {
		sonAlert = "_welldone";
		$("#msg_correction").attr("class", "messages-reponses bon");
		//$("#msg_correction .texteMsg").html("¡Muy bien! ¡Impresionante!");
	}
	$("#msg_correction").attr("class", "messages-reponses bon");*/
	$("#msg_correction .texteScore").html("Score : " + nbBonnesRepMot + "/" + (nbMots * 2 + 1) + ".");
	if (nbTentativesAct == nbTentatives) isVraieFin = true;
	
	if ($("#son_alert")[0] != null) {
		$("#son_alert")[0].pause();
		$("#son_alert").attr("src", "medias/sons/" + sonAlert + ".mp3");
		$("#son_alert")[0].play();
	}
	
	if (avecMsg == true) { // On affiche (ou non) le message de correction
		$("#msg_correction").fadeIn(1000);
		//$("#msg_correction").css("z-index", a++);
		dejaMsg++;
		setTimeout('faireDispMsg()', 4000);
	}
}

// Pour faire disparaitre un message
var alreadyDisp = false;
function faireDispMsg() {
	/*if (alreadyDisp == true) {
		alreadyDisp = false;
	} else {
		$("#msg_correction").fadeOut(1000);
		NbClicsMsg = 0;
		ClicMsg = false;
	}*/
	if (dejaMsg == 1) {
		$("#msg_correction").fadeOut(1000);
		dejaMsg = 0;
		if (isVraieFin == true) {
			isSolActif = true;
			voirSolution();
		}
	} else if (dejaMsg > 1) {
		dejaMsg--;
	}
}

// Pour voir la solution
function voirSolution() {
	var idBoucle = "";
	
	// On ne fait rien si le bouton est désactivé
	if (isSolActif == false) {
		//
	} else { // Si c'est un QCM bilan, alors on affiche la solution uniquement de la question actuelle
		
		var tmpL; var nombreRepALaQues = 0; var repComparee = "";
		for (l = 1; l <= numChamps; l++) { // pour chaque champ de saisie
			
			// On regarde le nombre de solutions possibles pour ce champ là
			if (typeof tbCorriges[l - 1] === 'string') nombreRepALaQues = 1;
			else nombreRepALaQues = tbCorriges[0].length;
			//for (k = 1; k <= nombreRepALaQues; k++) {
				tmpL = String(l);
				
				if (nombreRepALaQues == 1) repComparee = tbCorriges[l - 1]; // Dépend du
				else repComparee = tbCorriges[l - 1][0]; // nombre de solutions possibles
				
				
				$("#champ" + lpad(tmpL, 2, "0")).val(repComparee);
				
				
				
				
				$("#champ" + lpad(tmpL, 2, "0")).css("color", "#2f8d0a");
				$("#champ" + lpad(tmpL, 2, "0")).prop("disabled", true);
			//}
		}
	}
}





$(document).ready(function () {
	///////////////////////// POUR GRAINE DE GÉNIE /////////////////////////
	/**************** Gestion des cases du mots mélés ****************/
	$(".phrase_rep").click(function( e ) {
		if (!$(".btn_reco_new").is(":visible")) {
			//if (coulFondCase == true) $(this).css("background-color", "#cbcbcb");
			if ($(this).hasClass("vraiTxtTrous") == false) {
				if ($(this).css("background-color") != "rgb(203, 203, 203)") $(this).css("background-color", "#cbcbcb");
				else $(this).css("background-color", "white");
			}
		}
	});
	var caseAct = ""; var casePrec = "";
	document.getElementById("crossword").addEventListener('start', function(e) {
		e.preventDefault();
		var touch = e.touches[0];
		var xx = touch.pageX;
		var yy = touch.pageY;
		
		if ($("#" + document.elementFromPoint(xx, yy).id).attr("id").substr(0, 5) == "champ" && $("#" + document.elementFromPoint(xx, yy).id).attr("id").substr(-2, 2) != String($(".phrase_rep").length)) {
			caseAct = $("#" + document.elementFromPoint(xx, yy).id).attr("id");
			if (caseAct != casePrec) {
				if ($("#" + document.elementFromPoint(xx, yy).id).css("background-color") != "rgb(203, 203, 203)") $("#" + document.elementFromPoint(xx, yy).id).css("background-color", "#cbcbcb");
				else $("#" + document.elementFromPoint(xx, yy).id).css("background-color", "white");
			}
		}
	});
	document.getElementById("crossword").addEventListener('touchmove', function(e) {
		e.preventDefault();
		var touch = e.touches[0];
		var xx = touch.pageX;
		var yy = touch.pageY;
		
		if ($("#" + document.elementFromPoint(xx, yy).id).attr("id").substr(0, 5) == "champ" && $("#" + document.elementFromPoint(xx, yy).id).attr("id").substr(-2, 2) != String($(".phrase_rep").length)) {
			caseAct = $("#" + document.elementFromPoint(xx, yy).id).attr("id");
			if (caseAct != casePrec) {
				if ($("#" + document.elementFromPoint(xx, yy).id).css("background-color") != "rgb(203, 203, 203)") $("#" + document.elementFromPoint(xx, yy).id).css("background-color", "#cbcbcb");
				else $("#" + document.elementFromPoint(xx, yy).id).css("background-color", "white");
			}
			casePrec = caseAct;
		}
	});
	/**************** Gestion du corrigé ****************/
	$("#btn_solution, .btn_solu_newOLD").click(function( e ) {
		/*if ($("#crossword").is(":visible")) {
			$(".corrige").show();
			$("#crossword").hide();
		}*//* else {
			$(".corrige").hide();
			$("#crossword").show();
		}*/
		
		// On regarde quelles sont les bonnes réponses si on ne le sait pas déjà
		if (tbBonnesRep.length <= 0) {
			for (var n = 0; n < nbMots; n++) {
				for (var l = tbMots[n][0]; l <= tbMots[n][2]; l++) {
					for (var m = tbMots[n][1]; m <= tbMots[n][3]; m++) {
						var caseAct = $(".phrase_rep." + lpad(String(l), 2, "0") + "_" + lpad(String(m), 2, "0"));
						if (jQuery.inArray(caseAct.attr("class"), tbBonnesRep) == "-1") tbBonnesRep[tbBonnesRep.length] = caseAct.attr("class");
					}
				}
			}
		}
		
		for (l = 1; l <= $(".phrase_rep").length; l++) {
			var caseAct = $("#champ" + lpad(String(l), 2, "0"));
			if (jQuery.inArray(caseAct.attr("class"), tbBonnesRep) == "-1") caseAct.css("background-color", "white");
			else caseAct.css("background-color", "#2f8d0a");
		}
	});
	$(".corrige .btn_fermer").click(function( e ) {
		$(".corrige").hide();
		//alert("ok");
		//$(this).css("background-color", "#cbcbcb");
		//alert("#" + document.elementFromPoint(e.clientX, e.clientY).className);
		//alert("clients: "+ e.clientX+"/"+e.clientY+"; "+document.getElementById("champ02").pageX);
	});
	/**************** POUR METTRE EN CAPITALE LES LETTRES ENTRÉES ****************/
	/*$(".div_case .phrase_rep").keydown(function( event ) {//alert(String.fromCharCode(event.which).toUpperCase());
		// On regarde si c'est une lettre déja placée (on ne doit donc pas la changer...)
		var ligAct = 0; var colAct = 0;
		ligAct = Number($(this).attr("class").substr(-5, 2));
		colAct = Number($(this).attr("class").substr(-2, 2));
		
		var isDejaPlacee = false;
		for (l = 0; l < tbMots.length; l++) {
			if (LPsdfad(String(tbMots[l][0]), 2, "0") == ligAct && LPsdfad(String(tbMots[l][1]), 2, "0") == colAct) {
				isDejaPlacee = true;
				$(this).val(tbValeurs[tbMots[l][0] - 1][tbMots[l][1] - 1]);
			}
		}
		for (l = 0; l < tbLettresPlacees.length; l++) { // Lettres en plus...
			if (LPsdfad(String(tbLettresPlacees[l][0]), 2, "0") == ligAct && LPsdfad(String(tbLettresPlacees[l][1]), 2, "0") == colAct) {
				$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).val(tbValeurs[Number(tbLettresPlacees[l][0]) - 1][Number(tbLettresPlacees[l][1]) - 1]);
				$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).css("font-weight", "bold");
				$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).css("color", $(".numero").css("color"));
				isDejaPlacee = true;
				$(this).val(tbValeurs[tbLettresPlacees[l][0] - 1][tbLettresPlacees[l][1] - 1]);
			}
		}
		if (isDejaPlacee == false) {
			var regex = new RegExp("^[a-zA-Z0-9]+$");
			if (regex.test(String.fromCharCode(!event.charCode ? event.which : event.charCode))) {
				$(this).val(String.fromCharCode(event.which).toUpperCase());
			}
		}
	});
	$(".div_case .phrase_rep").keyup(function( event ) {
		var ligAct = 0; var colAct = 0;
		ligAct = Number($(this).attr("class").substr(-5, 2));
		colAct = Number($(this).attr("class").substr(-2, 2));
		
		var isDejaPlacee = false;
		for (l = 0; l < tbMots.length; l++) {
			if (LPsdfad(String(tbMots[l][0]), 2, "0") == ligAct && LPsdfad(String(tbMots[l][1]), 2, "0") == colAct) {
				isDejaPlacee = true;
				$(this).val(tbValeurs[tbMots[l][0] - 1][tbMots[l][1] - 1]);
			}
		}
		for (l = 0; l < tbLettresPlacees.length; l++) { // Lettres en plus...
			if (LPsdfad(String(tbLettresPlacees[l][0]), 2, "0") == ligAct && LPsdfad(String(tbLettresPlacees[l][1]), 2, "0") == colAct) {
				$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).val(tbValeurs[Number(tbLettresPlacees[l][0]) - 1][Number(tbLettresPlacees[l][1]) - 1]);
				$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).css("font-weight", "bold");
				$(".phrase_rep." + lpad(String(tbLettresPlacees[l][0]), 2, "0") + "_" + lpad(String(tbLettresPlacees[l][1]), 2, "0")).css("color", $(".numero").css("color"));
				isDejaPlacee = true;
				$(this).val(tbValeurs[tbLettresPlacees[l][0] - 1][tbLettresPlacees[l][1] - 1]);
			}
		}
		if (isDejaPlacee == false) {
			var regex = new RegExp("^[a-zA-Z0-9]+$");
			if (regex.test(String.fromCharCode(!event.charCode ? event.which : event.charCode))) {
				$(this).val(String.fromCharCode(event.which).toUpperCase());
			}
		}
		
		// Pour les touches "flèches"
		if (event.keyCode == 37 || event.keyCode == 38 || event.keyCode == 39 || event.keyCode == 40) {
			if (event.keyCode == 37) {colAct--; horiVerti = "hori";}
			if (event.keyCode == 38) {ligAct--; horiVerti = "verti";}
			if (event.keyCode == 39) {colAct++; horiVerti = "hori";}
			if (event.keyCode == 40) {ligAct++; horiVerti = "verti";}
			$(".phrase_rep." + lpad(String(ligAct), 2, "0") + "_" + lpad(String(colAct), 2, "0")).focus().select();
		} else { // Pour les autres touches
			if (horiVerti == "verti") ligAct++;
			else if (horiVerti == "hori") colAct++;
			$(".phrase_rep." + lpad(String(ligAct), 2, "0") + "_" + lpad(String(colAct), 2, "0")).focus().select();
		}
	});*/
	/**************** QUAND ON CLIQUE SUR LES PHRASES... ****************/
	/*var horiVerti = "";
	$(".phrases").click(function( event ) {
		var ligAct = 0; var colAct = 0;
		var numPhrase = Number($(this).attr("id").substr(-2, 2));
		ligAct = tbMots[numPhrase - 1][0];
		colAct = tbMots[numPhrase - 1][1];
		if (tbMots[numPhrase - 1][0] < tbMots[numPhrase - 1][2]) horiVerti = "verti";
		else horiVerti = "hori";
		
		$(".phrase_rep." + lpad(String(ligAct), 2, "0") + "_" + lpad(String(colAct), 2, "0")).focus().select();
	});*/
	// Pour selectionner automatiquement la valeur qu'il y a dans une case quand on arrive dessus
	/*$(".div_case .phrase_rep").focus(function() {
		var tempSelect = $(this);
		setTimeout(function() {
			tempSelect.select();
		}, 50);
	});*/
	
	/*$(".div_case .phrase_rep").mouseup(function(e){
		e.preventDefault();
	});*/
	
	
	
	
	/**************** POUR LES BOUTONS LETTRES ACCENTUÉES ****************/
	var derTrou = "";
	$(".btn_esp").click(function (event) {
		var $this = $(this);
		derTrou.val(derTrou.val() + $this.html());
		derTrou.focus();
	});
	$(".phrase_rep").focusin(function (event) {
		derTrou = $(this);
	});
	
	
	
	
	
	
	
	
	/**************** POUR LE BOUTON PRÉCÉDANT ****************/
	$(".btn_prec_new").click(function (event) {
		if (ecran_qu_act > 1) {
			
			// On vérifie chaque réponse
			tbReponsesUser = new Array();
			
			validerRep("sansScore");
			
			
			// On regarde le nombre de bonnes reps et on enregistre ce que l'on a fait
			/*var nbBonnesRep = 0;
			for (k = 1; k <= $(".champMot").length; k++) {
				if ($("#champ" + lpad(String(k), 2, "0")).css("background-color") == "rgb(203, 203, 203)" || $("#champ" + lpad(String(k), 2, "0")).css("background-color") == "rgb(124, 180, 75)" || $("#champ" + lpad(String(k), 2, "0")).css("background-color") == "rgb(202, 23, 25)") {
					tbReponsesUser[tbReponsesUser.length] = "champ" + lpad(String(k), 2, "0");
					for (l = 0; l < numChamps; l++) {
						if (k == Number(tbCorriges[l].substr(-2, 2))) {
							nbBonnesRep++;
						}
					}
				}
			}*/
			// Pour ne pas perturber l'affichage, on essaye de remettre l'écran avant la (fausse) validation
			$("#crossword, .bandeau_consigne, #phrases_crosswords").show();
			$(".pourc_bilan").hide();
			
			
			if (sessionStorage.getItem("validationFaite") == null || sessionStorage.getItem("validationFaite") == "null") {
				//sessionStorage.setItem("nbBonnesRepEcran" + sessionStorage.getItem("numEcranAct"), nbBonnesRep);
				sessionStorage.setItem("nbVraiBonnesRepEcran" + sessionStorage.getItem("numEcranAct"), nbMots);
				sessionStorage.setItem("reponsesUser" + sessionStorage.getItem("numEcranAct"), JSON.stringify(tbReponsesUser));
				
				for (l = 1; l <= tbReponsesUser.length; l++) {
					$("#" + tbReponsesUser[l - 1]).css("background-color", "rgb(203, 203, 203)");
				}
			}
			
			
			ecran_qu_act = Number(sessionStorage.getItem("numEcranAct"));
			$("#bouton_prec, .btn_prec_new, #bouton_suiv, .btn_suiv_new").css("opacity", "1");
			ecran_qu_act--; if (ecran_qu_act == 1) {$("#bouton_prec, .btn_prec_new").css("opacity", "0.5");}
			
			MAJNumEcran();
			sessionStorage.setItem("numEcranAct", Number(sessionStorage.getItem("numEcranAct")) - 1);
			
			//location.href = sessionStorage.getItem("numEcranAct") + "/index.html";
			if (sessionStorage.getItem("numEcranAct") == 1) location.href = "../index.html";
			else location.href = "../" + sessionStorage.getItem("numEcranAct") + "/index.html";
		}
		ecran_qu_act = Number(sessionStorage.getItem("numEcranAct"));
	});
	
	
	/**************** POUR LE BOUTON SUIVANT ****************/
	$(".btn_suiv_new").click(function (event) {
		if (ecran_qu_act < ecran_qu_tot) {
			
			// On vérifie chaque réponse
			tbReponsesUser = new Array();
			
			validerRep("sansScore");
			
			// On regarde le nombre de bonnes reps et on enregistre ce que l'on a fait
			/*var nbBonnesRep = 0;
			for (k = 1; k <= $(".champMot").length; k++) {
				if ($("#champ" + lpad(String(k), 2, "0")).css("background-color") == "rgb(203, 203, 203)" || $("#champ" + lpad(String(k), 2, "0")).css("background-color") == "rgb(124, 180, 75)" || $("#champ" + lpad(String(k), 2, "0")).css("background-color") == "rgb(202, 23, 25)") {
					tbReponsesUser[tbReponsesUser.length] = "champ" + lpad(String(k), 2, "0");
					for (l = 0; l < numChamps; l++) {
						if (k == Number(tbCorriges[l].substr(-2, 2))) {
							nbBonnesRep++;
						}
					}
				}
			}achanger*/
			/*tbReponsesUser = new Array();
			for (l = 1; l <= $("#crossword .phrase_rep").length; l++) {
				var numCase = "";
				if (l <= 9) numCase = lpad(String(l), 2, "0");
				else numCase = String(l);
				
				if ($("#champ" + numCase).val() != "") tbReponsesUser[l - 1] = $("#champ" + numCase).val();
				else tbReponsesUser[l - 1] = "";
			}*/
			// Pour ne pas perturber l'affichage, on essaye de remettre l'écran avant la (fausse) validation
			$("#crossword, .bandeau_consigne, #phrases_crosswords").show();
			$(".pourc_bilan").hide();
			
			
			if (sessionStorage.getItem("validationFaite") == null || sessionStorage.getItem("validationFaite") == "null") {
				//sessionStorage.setItem("nbBonnesRepEcran" + sessionStorage.getItem("numEcranAct"), nbBonnesRep);
				sessionStorage.setItem("nbVraiBonnesRepEcran" + sessionStorage.getItem("numEcranAct"), nbMots);
				sessionStorage.setItem("reponsesUser" + sessionStorage.getItem("numEcranAct"), JSON.stringify(tbReponsesUser));
				
				for (l = 1; l <= tbReponsesUser.length; l++) {
					$("#" + tbReponsesUser[l - 1]).css("background-color", "rgb(203, 203, 203)");
				}
			}
			
			
			ecran_qu_act = Number(sessionStorage.getItem("numEcranAct"));
			//if (sessionStorage.getItem("validationFaite") == null || sessionStorage.getItem("validationFaite") == "null") validerRepPourCalcul("sansScore");
			
			$("#bouton_prec, .btn_prec_new, #bouton_suiv, .btn_suiv_new").css("opacity", "1");
			ecran_qu_act++; if (ecran_qu_act == ecran_qu_tot) {$("#bouton_suiv, .btn_suiv_new").css("opacity", "0.5"); 
				if (!$(".btn_reco_new").is(":visible")) $("#btn_valider, .btn_valider_new").show();}
			
			MAJNumEcran();
			
			sessionStorage.setItem("numEcranAct", Number(sessionStorage.getItem("numEcranAct")) + 1);
			
			
			if (sessionStorage.getItem("numEcranAct") == 2) location.href = sessionStorage.getItem("numEcranAct") + "/index.html";
			else location.href = "../" + sessionStorage.getItem("numEcranAct") + "/index.html";
		}
		ecran_qu_act = Number(sessionStorage.getItem("numEcranAct"));
	});
	
	/**************** POUR LE BOUTON BILAN ****************/
	var vraiTitre = $(".bandeau_titre").text();
	$(".btn_bilan").click(function (event) {
		$(".btn_voir_correction").show();
		$(".btn_prec_new, .num_ecran, .btn_suiv_new").hide();
		
		$(".btn_bilan").hide();
		$("#crossword, #phrases_crosswords").hide();
		$(".bandeau_consigne").hide();
		
		$("#img_sol").hide();
		$(".btn_solu_reelle").hide();
		
		var nbBonnesRepTotal = 0;
		var nbVraiBonnesRepTotal = 0;
		var scoreTotal = 0;
		
		for (var ibilan = 1; ibilan <= nbEcransTot; ibilan++) {//alert(sessionStorage.getItem("nbBonnesRepEcran" + ibilan));
			if (sessionStorage.getItem("nbBonnesRepEcran" + ibilan) != null && sessionStorage.getItem("nbBonnesRepEcran" + ibilan) != "null") nbBonnesRepTotal += Number(sessionStorage.getItem("nbBonnesRepEcran" + ibilan));
			if (sessionStorage.getItem("nbVraiBonnesRepEcran" + ibilan) != null && sessionStorage.getItem("nbVraiBonnesRepEcran" + ibilan) != "null") nbVraiBonnesRepTotal += Number(sessionStorage.getItem("nbVraiBonnesRepEcran" + ibilan));
			//alert(nbBonnesRepTotal + " // " + nbVraiBonnesRepTotal + " // " + scoreTotal);
		}
		//alert(nbBonnesRepTotal + " / "+nbVraiBonnesRepTotal);
		scoreTotal = Math.round((nbBonnesRepTotal / nbVraiBonnesRepTotal) * 100);
		sessionStorage.setItem("nbBonnesRepTotal", nbBonnesRepTotal);//alert(nbBonnesRepTotal);
		sessionStorage.setItem("nbVraiBonnesRepTotal", nbVraiBonnesRepTotal);
		sessionStorage.setItem("scoreTotal", scoreTotal);
		
		nbBonnesRep = sessionStorage.getItem("nbBonnesRepTotal");
		vraiNbBonnesRep = sessionStorage.getItem("nbVraiBonnesRepTotal");
		scorePourc = sessionStorage.getItem("scoreTotal");
		
		if (isLangue == "ang") {
			if (scorePourc == 100)
				$(".pourc_bilan_langues p").html("Score: " + vraiNbBonnesRep + "/" + vraiNbBonnesRep + "<br />Good Job!");
			else
				$(".pourc_bilan_langues p").html("Score: " + nbBonnesRep + "/" + vraiNbBonnesRep + "<br />Sorry, wrong answer! Try again!");
		} else if (isLangue == "esp") {
			if (scorePourc == 100)
				$(".pourc_bilan_langues p").html("Resultado: " + vraiNbBonnesRep + "/" + vraiNbBonnesRep + "<br />¡Enhorabuena!");
			else
				$(".pourc_bilan_langues p").html("Resultado: " + nbBonnesRep + "/" + vraiNbBonnesRep + "<br />¡Hay errores, vuelve a intentarlo!");
		} else {
			/*if (scorePourc >= 0 && scorePourc < 50)
				$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + vraiNbBonnesRep + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />La plupart des notions ne sont pas maîtrisées.<br />Reportez-vous à votre cours pour identifier vos erreurs puis recommencez le test.");
			else if (scorePourc >= 50 && scorePourc < 70)
				$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + vraiNbBonnesRep + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />Il vous manque encore des connaissances sur ce cours.<br />Reportez-vous à la correction pour identifier vos erreurs et définir les points du cours concernés.");
			else if (scorePourc >= 70 && scorePourc < 99)
				$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + vraiNbBonnesRep + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />C’est bien ! La majorité des notions semblent acquises mais certaines peuvent être à revoir ou à approfondir.");
			else if (scorePourc == 100)
				$(".pourc_bilan p").html("<b>Réponses correctes :</b> " + nbBonnesRep + "/" + vraiNbBonnesRep + "<br /><br /><b>Taux de réussite :</b> " + scorePourc + "&#160;%<br /><br />Félicitations ! Vous maîtrisez parfaitement toutes les notions du cours !");*/
			
			
			$("audio").each(function() {
				$(this)[0].pause();
				//if (!isNaN($(this).duration))$(this).currentTime = 0;
				if (!isNaN($(this)[0].duration)) $(this)[0].currentTime = 0;
			});
			
			if (scorePourc >= 0 && scorePourc < 50) {
				$(".pourc_bilan p").html("<b>Score:</b> " + scorePourc + "%<br /><br />Oops! Try again!");
				$(".son_alert1")[0].play();
			} else if (scorePourc >= 50 && scorePourc < 100) {
				$(".pourc_bilan p").html("<b>Score:</b> " + scorePourc + "%<br /><br />I bet you can do better!");
				$(".son_alert2")[0].play();
			} else if (scorePourc == 100) {
				$(".pourc_bilan p").html("<b>Score:</b> " + scorePourc + "%<br /><br />Congratulations!");
				$(".son_alert3")[0].play();
			}
		}
		
		$(".pourc_bilan").show();
		
		//$(".bandeau_titre").text("Bilan");
	});
	
	
	
	
	/**************** POUR LE BOUTON BILAN ****************/
	var vraiTitre = $(".bandeau_titre").text();
	$(".btn_bilan_OLD").click(function (event) {
		$(".btn_solu_new").show();
		
		$(".btn_bilan").hide();
		$(".crossword_resp").hide();
		$(".bandeau_consigne").hide();
		
		$(".pourc_bilan").show();
		
		$(".bandeau_titre").text("Bilan");
	});
	// Pour afficher la solution (après avoir validé) dans le cas des bilans
	/**************** POUR LE BOUTON VOIR LA CORRECTION ****************/
	$(".btn_voir_correction").click(function (event) {
		var lochref = "";
		if (sessionStorage.getItem("numEcranAct") == "1") lochref = "index.html";
		else lochref = "../index.html";
		sessionStorage.setItem("numEcranAct", 1);
		location.href = lochref;
	});
	/**************** POUR LE BOUTON VOIR LA CORRECTION ****************/
	var vraiTitre = $(".bandeau_titre").text();
	$(".btn_solu_new").click(function (event) {
		$(".btn_solu_new").hide();
		
		$(".btn_bilan").show();
		$(".crossword_resp").show();
		$(".bandeau_consigne").show();
		
		$(".pourc_bilan").hide();
		
		$(".bandeau_titre").text(vraiTitre);
	});
	
	
	
	
	
	/**************** POUR LE BOUTON AIDE ****************/
	$("#btn_aide").click(function (event) {
		var $this = $(this);
		/*$("#aide .text").html($(".comment-text[data-value='" + $this.attr('data-value') + "']").html());*/
		if ($("#aide").is(":visible")) $("#aide").hide();
		else $("#aide").show();
		//$("#aide .close").show();
	});
	
	$("#btn_aide").mouseover(function (event) {
		var $this = $(this);
		$("#img_bouton_aide").attr("src", "medias/bouton-aide-rol.png");
	});
	
	$("#btn_aide").mouseout(function (event) {
		var $this = $(this);
		$("#img_bouton_aide").attr("src", "medias/bouton-aide.png");
	});
	
	$("#btn-fermer-aide").click(function (event) {
		var $this = $(this);
		$("#aide").hide();
		// rien à faire ... car un clic n'importe où fermer la fenêtre
	});
	
	$("#btn-fermer-aide").mouseover(function (event) {
		var $this = $(this);
		$(".btn_fermer").attr("src", "medias/bouton-fermer-rol.png");
	});
	
	$("#btn-fermer-aide").mouseout(function (event) {
		var $this = $(this);
		$(".btn_fermer").attr("src", "medias/bouton-fermer.png");
	});
	
	
	/**************** POUR LE BOUTON VALIDER ****************/
	/* Clic sur le bouton VALIDER ----- NE SERT PAS */
	$("#bouton_valider").click(function (event) {
		/*var $this = $(this);
		// Pour tester si le nombre de tentatives n'est pas dépassé
		if (nbTentativesAct == nbTentatives) {
			if (avecMsg == true) { // On affiche (ou non) le message de correction
				$("#msg_correction").show();
			}
			$("#bouton_valider").hide();
		}*/
		ClicMsg = true; NbClicsMsg = 0;
	});
	
	$("#bouton_valider").mouseover(function (event) {
		var $this = $(this);
		$(".btn_valider").css("background-image", "url(medias/bouton-valider-rol.png)");
	});
	
	$("#bouton_valider").mouseout(function (event) {
		var $this = $(this);
		$(".btn_valider").css("background-image", "url(medias/bouton-valider.png)");
	});
	
	
	/**************** POUR LE BOUTON RECOMMENCER ****************/
	$("#bouton_recommencer, .btn_reco_new").click(function (event) {
		var $this = $(this);
		//location.reload();
		
		
		var numEcranAct = sessionStorage.getItem("numEcranAct");
		
		// On doit remettre d'abord à zéro chaque variable de session
		sessionStorage.setItem("numEcranAct", null);
		for (var ibilan = 1; ibilan <= nbEcransTot; ibilan++) {
			sessionStorage.setItem("nbBonnesRepEcran" + ibilan, null);
			sessionStorage.setItem("nbVraiBonnesRepEcran" + ibilan, null);
			sessionStorage.setItem("reponsesUser" + ibilan, null);
		}
		sessionStorage.setItem("nbBonnesRepTotal", null);
		sessionStorage.setItem("nbVraiBonnesRepTotal", null);
		sessionStorage.setItem("scoreTotal", null);
		sessionStorage.setItem("validationFaite", null);
		
		// On charge la bonne page
		if (numEcranAct == "1") location.href = "index.html";
		else location.href = "../index.html";
		
		
		for (l = 1; l <= numChamps; l++) {
			document.getElementById("champ" + lpad(String(l), 2, "0")).disabled = false;
		}
		$(".texteScore").html("ScoreScoreScore");
	});
	
	$("#bouton_recommencer").mouseover(function (event) {
		var $this = $(this);
		$(".btn_recommencer").css("background-image", "url(medias/bouton-recommencer-rol.png)");
		//$("#img_bouton_effacer").attr("src", "medias/bouton-effacer-rol.png");
	});
	
	$("#bouton_recommencer").mouseout(function (event) {
		var $this = $(this);
		$(".btn_recommencer").css("background-image", "url(medias/bouton-recommencer.png)");
		//$("#img_bouton_effacer").attr("src", "medias/bouton-effacer.png");
	});
	/**************** POUR LE BOUTON EFFACER ****************/
	$("#bouton_effacer").click(function (event) {
		var $this = $(this);
		/*if (coulFondCase == true) coulFondCase = false;
		else coulFondCase = true;*/
		
		$(".phrase_rep").css("background-color", "white");
	});
	
	$("#bouton_effacer").mouseover(function (event) {
		var $this = $(this);
		$(".btn_effacer").css("background-image", "url(medias/bouton-prec-rol.png)");
	});
	
	$("#bouton_effacer").mouseout(function (event) {
		var $this = $(this);
		$(".btn_effacer").css("background-image", "url(medias/bouton-prec.png)");
	});
	
	
	/**************** POUR LE BOUTON SOLUTION ****************/
	// On désactive le bouton si la variable correspondante est sur false
	if (isSolActif == true) {
		$("#btn_solution").click(function (event) {
			var $this = $(this);
			/*$("#btn_solution").hide();*/
			//if (isBilan == false) $("#bouton_valider").hide();
			$("#btn-voirreponse-util").show();
			$("#img_contenu_exercice").attr("src", "medias/contenu_corrige.png");
			$(".etiquette").each(function () {
				$(".etiquette").hide();
			});
		});
		
		$("#btn_solution").mouseover(function (event) {
			var $this = $(this);
			$("#img_bouton_solution").attr("src", "medias/btn_corrige_rol.png");
		});
		
		$("#btn_solution").mouseout(function (event) {
			var $this = $(this);
			$("#img_bouton_solution").attr("src", "medias/btn_corrige.png");
		});
	} else { // On force l'affichage de la flèche pour faire comprendre que le bouton est désactivé
		$("#btn_solution").mouseover(function (event) {
			var $this = $(this);
			$("#img_bouton_solution").css("cursor", "default");
		});
	}
	
	
	/**************** POUR L'AIDE ****************/
	/*var ClicAide = false; var NbClicsAide = 0; var alreadyClicked = false;
	$("#btn_aide").click(function (event) {
		var $this = $(this);
		//$("#aide .text").html($(".comment-text[data-value='" + $this.attr('data-value') + "']").html());
		//if ($("#img_bouton_aide").attr("src", "medias/bouton-aide-rol.png"))
		//if ($("#img_bouton_aide").attr("src") != "medias/bouton-aide-rol.png")
		$("#aide").show();
		ClicAide = true; NbClicsAide = 0;
		//$("#aide .close").show();
	});*/
	
	
	var ClicMsg = false; var NbClicsMsg = 0;
	// clic général pour faire disparaître l'aide + les messages de validation
    $("#idBody").click(function (event) {
		if (ClicMsg == true) { // pour la validation
			NbClicsMsg++;
			if (NbClicsMsg > 1) {
				$("#msg_correction").hide();
				NbClicsMsg = 0;
				ClicMsg = false; alreadyDisp = true;
			}
		}
		/*if (ClicAide == true) { // pour l'aide
			NbClicsAide++;
			if (NbClicsAide > 1) {
				$("#aide").hide();
				NbClicsAide = 0;
				ClicAide = false;
			}
		}*/
	});
	
	/**************** POUR FAIRE DISPARAITRE LES DIFF FENETRES IPAD ****************/
	document.getElementById("idBody").addEventListener('touchstart', function(e) {
		//e.preventDefault();
		if (ClicMsg == true) { // pour la validation
			NbClicsMsg++;
			if (NbClicsMsg > 1) {
				$("#msg_correction").hide();
				NbClicsMsg = 0;
				ClicMsg = false; alreadyDisp = true;
			}
		}
		/*if (ClicAide == true) { // pour l'aide
			NbClicsAide++;
			if (NbClicsAide > 1) {
				$("#aide").hide();
				NbClicsAide = 0;
				ClicAide = false;
			}
		}*/
		//$("#msg_bravo").hide();
	});

});

/**************** FONCTION LPAD ****************/
function LPsdfad(ContentToSize,PadLength,PadChar) {
	var PaddedString=ContentToSize.toString();
	for(i=ContentToSize.length+1;i<=PadLength;i++) {
		PaddedString=PadChar+PaddedString;
	}
	return PaddedString;
}



function MAJNumEcran() {
	ecran_qu_tot = nbEcransTot;
	$(".num_ecran_act").text(String(ecran_qu_act));
	$(".num_ecran_tot").text(String(ecran_qu_tot));
	
	
	$("#bouton_prec, .btn_prec_new, #bouton_suiv, .btn_suiv_new").css("opacity", "1");
	if (ecran_qu_act == ecran_qu_tot) {$("#bouton_suiv, .btn_suiv_new").css("opacity", "0.5"); 
		if (!$(".btn_reco_new").is(":visible") && (sessionStorage.getItem("validationFaite") == null || sessionStorage.getItem("validationFaite") == "null")) $("#btn_valider, .btn_valider_new").show();}
	if (ecran_qu_act == 1) {$("#bouton_prec, .btn_prec_new").css("opacity", "0.5");}
}